@echo off
rem latest change 14 Jan -93   uses pgp ver 2.3A
echo:
echo              SIGNED CHECKSUMS AGAINST VIRUS 
echo:
echo  This archive file is protected with a signed checksum.
echo:
rem change to your own preferred directory.

rem have user entered a filename ?
if "%1"=="" goto syntax
goto pass10
:syntax
echo:
echo                  Correct syntax is:
echo:
echo                  CHKSIGN.BAT filename
echo:
echo      where 'filename' is the ZIP-archive that you want verify
echo      (without extension)
goto end

:pass10 

c:
cd \unsigned
rem here comes the verification of the signature. 
rem To move out the signature, we must first copy it out from archive
rem that the signer created at the signing stage.
pkunzip %1.ZIP 0signed.zip 
if errorlevel 1 goto end
rem and then delete it from archive.
pkzip -d %1.ZIP 0signed.zip 
if errorlevel 1 goto end
rem and finaly copy out the signaturefile itself.
pkunzip 0signed %1.ASC
if errorlevel 1 goto end

rem verify the archive
c:\pgp\pgp +textmode=off %1.ASC %1.ZIP
if errorlevel 1 goto end
pause

rem put back signatur into archive
pkzip -m %1.ZIP 0signed.zip 
if errorlevel 1 goto end

rem clean up
del %1.ASC

:quit
echo      The archive wich contains the signature is named to 0SIGNED.ZIP.
echo      The original archive can now be opened in usual manner.
echo Done. 
:end     