@echo off
rem latest change; 7 Jul -94   needs pgp ver 2.3A, and MSDOS 6.x
rem comments on this to
rem Internet: laszlo@instrlab.kth.se
rem BBS:      laszlo  at TCL-Haninge, 08-50031125, nodenumber 2:201/600.7
rem
rem signes a ZIP-archive in current directory, and moves it to floppy
rem change directory's and logotype to suit your own taste

rem to make it sign archives say, at night, without any user input,
rem then put your passphrase into the memory, using SET PGPPASS=...

rem test if previous signing was cleaned up properly = was all sucsessful ?
if exist c:\unsigned\*.* goto end

rem have user entered a filename ?
if "%1"=="" goto syntax
goto pass10
:syntax
echo:
echo                  Correct syntax is:
echo:
echo                  DO_SIGN.BAT filename
echo:
echo      where 'filename' is the ZIP-archive that you want verify
echo      (without extension)
goto end2

:pass10
c:
cd \
mkdir unsigned
cd unsigned
copy c:\pgp\signing\%1.ZIP \unsigned\%1.zip
rem repack to the current pkzipversion, 2.04g, to avoid any
rem mixing with different ZIP-versions.
rem open the archive
pkunzip -d %1.zip
if errorlevel 1 goto end
del \unsigned\%1.zip

rem Insert your favorite viruschecker here

rem ZIP the archive
rem Note. To avoid incompatibility with the UNIX version of 
rem pkzip, ver 2.xx, do NOT use the -ex flag to get maximum compression.
pkzip %1 -m -r
if errorlevel 1 goto end
rem repacking done

rem add a logotype. 
rem Some sites automatically removes/replaces logo's
rem so dont count on that it will remain.
pkzip %1.ZIP -z<c:\pgp\signing\default.log
if errorlevel 1 goto end

rem do a selftest of pgp itself
rem c:\pgp\pgp pgpsig.asc pgp.exe
rem if errorlevel 1 goto end

rem sign the archive
c:\pgp\pgp -sba +textmode=off %1.ZIP -ulaszlo@instrlab.kth.se
if errorlevel 1 goto end
echo Digital signatur fr filen '%1.ZIP' >>%1.ASC

rem copy info-files
copy c:\pgp\signing\id_msg.asc
copy c:\pgp\signing\readme.txt
copy c:\pgp\signing\chksign.bat
copy c:\pgp\signing\do_sign.bat

rem move info-files + signature into archive as 0signed.zip
pkzip 0signed -m %1.ASC id_msg.asc readme.txt chksign.bat do_sign.bat
if errorlevel 1 goto end
pkzip %1.ZIP -m 0signed.zip
if errorlevel 1 goto end

rem verify the signature by running the CHKSIGN.BAT
call c:\pgp\signing\CHKSIGN.BAT %1

rem move the signed archive to floppy
copy \unsigned\%1.zip a:\%1.zip
rem check for 'full disk' condition before cleaning up
cd \pgp\signing
if not exist a:\%1.zip goto end2

rem clean up without askin for users respond
cd \
deltree c:\unsigned

rem deltree /Y c:\unsigned

rem del c:\pgp\signing\%1.ZIP
rem del c:\unsigned\%1.ZIP
rem rmdir c:\unsigned
rem If the archive contained any subdirectorys, there is no way
rem a .BAT file itself can clean it up. We need a more intelligent
rem program for this
rem added 14 jan -94
rem With MSDOS 6.x we have the command DELTREE that do exactly this.
rem i will add it to this batchfile later.


:end
rem test if we cleaned up properly = was all sucsessful ?
if not exist c:\unsigned\*.* goto end2
echo:
echo    Something failed ! Press No if you cant read the cause above
echo    One known cause is that the archivefile [%1.ZIP ]
echo    have a filename wich contains some non-english character.
echo:    
echo:
echo    Or previous batch did left files in /unsigned.
echo:   Could be due to a 'diskfull' condition
rem force user to respond to a clean up of the directory /unsigned
rem there might be stuff there wich should not be deleted
cd \
deltree c:\unsigned
:end2